import * as i0 from '@angular/core';
import { InjectionToken, Injectable, Inject, NgModule } from '@angular/core';
import { Mapper as Mapper$1, MapperConfiguration } from '@dynamic-mapper/mapper';

const MAPPING_PROFILE = new InjectionToken('MappingProfile');
class Mapper extends Mapper$1 {
    constructor(profiles) {
        super(new MapperConfiguration(cfg => profiles.forEach(p => cfg.addProfile(p))));
    }
    /** @nocollapse */ static ɵfac = function Mapper_Factory(t) { return new (t || Mapper)(i0.ɵɵinject(MAPPING_PROFILE)); };
    /** @nocollapse */ static ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: Mapper, factory: Mapper.ɵfac });
}
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(Mapper, [{
        type: Injectable
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [MAPPING_PROFILE]
            }] }]; }, null); })();

function createProfileProvider(profile) {
    return { provide: MAPPING_PROFILE, useClass: profile, multi: true };
}
class MapperModule {
    static withProfiles(profiles) {
        return {
            ngModule: MapperModule,
            providers: profiles.map(createProfileProvider)
        };
    }
    /** @nocollapse */ static ɵfac = function MapperModule_Factory(t) { return new (t || MapperModule)(); };
    /** @nocollapse */ static ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: MapperModule });
    /** @nocollapse */ static ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [Mapper] });
}
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(MapperModule, [{
        type: NgModule,
        args: [{
                providers: [Mapper]
            }]
    }], null, null); })();

/*
 * Public API Surface of mapper-integration
 */

/**
 * Generated bundle index. Do not edit.
 */

export { MAPPING_PROFILE, Mapper, MapperModule, createProfileProvider };
//# sourceMappingURL=dynamic-mapper-angular.mjs.map
